/**
 * Changelog
 *
 * @package         Sourcerer
 * @version         4.4.10
 *
 * @author          Peter van Westen <peter@nonumber.nl>
 * @link            http://www.nonumber.nl
 * @copyright       Copyright © 2015 NoNumber All Rights Reserved
 * @license         http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

/**
 * + Added
 * ! Removed
 * ^ Changed
 * # Fixed
 */

09-May-2015 : v4.4.10
 + Added translations: cs-CZ
 ^ Updated translations: de-DE, el-GR, pt-PT
 ^ [J3] Changed way the editor resize functionality works
 ^ [J3] Improved rendering speed on pages with large contents
 # [J3] Fixed issue with editor button showing to users without edit/create permissions
 # [J3] Fixed issue with indent tab image not being placed
 # [J3] Fixed issue with resize on editor not working

25-Feb-2015 : v4.4.9
 ^ Updated translations: uk-UA
 # [PRO] Fixed issue with components select list only saving one value

08-Jan-2015 : v4.4.8
 ! Removed compatibility for php versions under 5.3.13
 ! [J3] Removed compatibility for Joomla 3 versions under 3.3.0
 ^ Updated translations: pl-PL, pt-PT, tr-TR
 # Fixed issue with Free version being able to be installed over the Pro version

25-Nov-2014 : v4.4.7
 ^ Cleans left over {source} tags from head part possibly placed there by other extensions
 # Fixed issue with error about nnFile on installation on some setups
 # Fixed issues with whitespace being stripped from html between php blocks
 # [PRO] Fixed issues with duplicate rows in update_sites table

28-Oct-2014 : v4.4.6
 # Fixed issue with plugin not working on jDownloads frontend view

02-Oct-2014 : v4.4.5
 # Fixed issue with plugin not being run over introtext/fulltext on onContentPrepare event

10-Sep-2014 : v4.4.4
 # Fixed issue with error about undefined object

10-Sep-2014 : v4.4.3
 ^ Updated translations: id-ID, nl-NL
 # Fixed issue with {source} tags being stripped from frontend editor fields

11-Aug-2014 : v4.4.2
 ^ Updated translations: lt-LT
 # [J2.5] Fixed issue with editor button popup not working

10-Aug-2014 : v4.4.1
 # Fixed issue with html potentially being interpreted as php (causing errors)

10-Aug-2014 : v4.4.0
 + Added ability to include files simply via {source file=myfile.php}
 ! [J3] Removed compatibility for Joomla 3 versions under 3.2.2
 ^ Refactored code
 ^ Updated translations: id-ID, pl-PL
 # Fixed issue with tags being converted in com_myjspace edit forms
 # [J2] Fixed issue with errors after upgrade to Joomla 3
 # [J3] Fixed issue with tags not being handled in search results

16-Apr-2014 : v4.3.3
 + Added translations: id-ID
 ^ Cleaned up some code
 # Fixed issue with html structure issues when tags are directly inside html 5 elements
 # Fixed issue with some missing language strings in some occasions
 # [J3.3] Fixed some Joomla 3.3 incompatibility issues

27-Feb-2014 : v4.3.2
 ^ Improved rendering speed on list views
 # Fixed issue with breaking of xml view of com_jmap
 # Fixed issue with feeds being broken
 # Fixed issue with some missing language strings in some occasions

30-Dec-2013 : v4.3.1
 # Fixed issue with tags being encoded in frontend edit views

19-Dec-2013 : v4.3.0
 ^ Improved some code in NoNumber Framework which improves page load speed
 ^ Updated translations: pt-PT
 # SECURITY FIX: Fixed issue with editor button popup window being accessible to all registered users

20-Nov-2013 : v4.2.7
 # [J3.2] Fixed issue with quotes from Sourcerer editor being converted to html entities when inserted

18-Nov-2013 : v4.2.6
 # Fixed installation error about duplicate entry on some MySQL 5.6 setups
 # [FREE] Fixed issue with example code being messed up after saving plugin settings
 # [J3] Fixed issue with code inserted incorrectly on Firefox (adding line numbers)

08-Nov-2013 : v4.2.5
 # [J3.1] Fixed issue with modal popups not working

07-Nov-2013 : v4.2.4
 # [J3] Fixed Joomla 3.2 compatibility issues

03-Nov-2013 : v4.2.3
 # Fixed issue with icons not working

01-Nov-2013 : v4.2.2
 + Added translations: es-ES, et-EE, uk-UA
 ^ Changed javascript minification to use Google Closure
 ^ Updated translations: de-DE, ja-JP, pl-PL, pt-PT
 # Fixed issue with header stuff (javascript/css) not always being added in category views

25-Sep-2013 : v4.2.1
 + Added translations: tr-TR
 # Fixed issue with opening tags not being converted on some setups
 # Fixed issue with tags sometimes appearing in title tags and title attributes
 # Fixed issue with warning message showing when item has unvalid user id as creator
 # [J2] Improved rendering speed on list views

13-Aug-2013 : v4.2.0
 ! [J2] Removed compatibility for Joomla 2.5 versions lower than 2.5.10
 ! [J3.0] Removed compatibility for Joomla 3 versions lower than 3.1.0
 # [J3.0] Improved rendering speed on list views
 # [J3] Fixed issue with editor button not getting styled correctly on TinyMCE

19-Jun-2013 : v4.1.9
 # [J3] Fixed issue with icons in the Sourcerer editor buttons not working correctly

13-Jun-2013 : v4.1.8
 ^ Improved minification of js files
 ^ [J2] Converted images in (editor) buttons to font icons
 # Fixed issue with some language strings in comments not being converted

30-May-2013 : v4.1.7
 ^ [J2] Minified the editor javascript
 # Fixed issue with article security settings being applied to modules that have content prepare enabled

22-Apr-2013 : v4.1.6
 # Fixed issue with installation manifest details not updating
 # Fixed issue with update manager not seeing latest version (caused by manifest)

18-Apr-2013 : v4.1.5
 ^ Updated translations: it-IT, ja-JP
 # [J3] Fixed issue with & in selection being converted to &amp; in Sourcerer editor

28-Mar-2013 : v4.1.4
 ^ Changed messaging on installation on unsupported Joomla versions
 ^ Cleaned up some code (syntax)

18-Mar-2013 : v4.1.3
 # Fixed issue with span tags around the {source 0} tag being removed

11-Mar-2013 : v4.1.2
 + Added less files for generating css files
 ! [J2] Removed unused files from code editor
 ^ Minified css and js files
 ^ Updated translations: lt-LT
 # Fixed some issues with installation breaking and throwing errors on some setups

10-Jan-2013 : v4.1.1
 # [J2] Fixed issue with editor button not having icon due to missing css file
 # [J3] Fixed issue with editor button popup not working (javascript not being loaded)

30-Dec-2012 : v4.1.0
 ^ Cleaned up code
 ^ Moved media files to Joomla media folder
 ^ Updated translations: fr-FR
 # Fixed error about XML setup file on first install

11-Dec-2012 : v4.0.4
 # Fixed issue with php variables being set inside custom code not being gloabally available

11-Dec-2012 : v4.0.3
 ! Removed eval code and debugging options (is now left to php error handling)
 ^ Updated translations: zh-CN
 # [J2] Fixed issue with errors about xml files on installation

14-Nov-2012 : v4.0.2
 + Added translations: zh-CN
 # Fixed issue with error messages about XML file on installation on some setups

10-Nov-2012 : v4.0.1
 # [FREE] Fixed issue with version number causing problems with version check in the NoNumber Extension Manager

09-Nov-2012 : v4.0.0
 + [J3] Added Joomla 3 support
 ! [J1.5] Removed Joomla 1.5 support

09-Nov-2012 : v3.3.0
 + [FREE] Added default indentation to Free version
 ! Removed option to preserve colors
 ! Removed option to switch of preserving indentation
 ! [J1.5] LAST VERSION COMPATIBLE WITH JOOMLA 1.5

23-Oct-2012 : v3.2.2
 # Fixed issue with php code not working when there are nbsp entities in source
 # [J2] Fixed issue with errors with Phoca PDF
 # [J2] Fixed issue with inserted code into JCE editor not showing

20-Sep-2012 : v3.2.1
 ^ Updated translations: el-GR
 # Fixed issue with tags being handled in edit for of jcal, jevent and some others

29-Jun-2012 : v3.2.0
 + Added ready to use document/doc object variables
 + Added translations: sv-SE
 ! Removed ability to install on Joomla 1.6 and 1.7
 ! Removed ability to install on setups with php 5.2 or lower
 ^ Cleaned a lot of code
 # Fixed issue with tags being interpreted inside the Josetta form

01-May-2012 : v3.1.0
 + Added translations: zh-TW
 ^ Improved protecting of edit forms to only protect fields (so tags work outside form fields)
 ^ Increased page load speed by changing how xml files are loaded

12-Apr-2012 : v3.0.3
 # Fixed issue with language strings not being converted in editor button popup

11-Apr-2012 : v3.0.2
 # [J1.5] Fixed issue with settings slides not working correctly

10-Apr-2012 : v3.0.1
 # SECURITY FIX: Fixed URL injection vulnerability in NoNumber Framework

07-Apr-2012 : v3.0.0
 ^ Changed some language strings
 ^ Cleaned up code syntax
 ^ Moved editor button settings to system plugin
 ^ Now available as Pro and Free version
 ^ Updated translations: de-DE
 # Fixed issue with forbidden php functions like exec also blocking functions like curl_exec

01-Mar-2012 : v2.11.4
 ^ Improved protection of editor fields
 ^ [J1.7+] Improved handling of tags in pdfs
 # Fixed issue with php 'non-object' error when there are users with ids lower than 30
 # [J1.7+] Fixed styling issues in Editor Button popup

13-Jan-2012 : v2.11.3
 + Added translations: bg-BG, pl-PL, pt-PT, th-TH
 ^ Cleaned up more code
 ^ Updated translations: de-DE
 # Fixed issue with installer not removing the folder/zip from the tmp
 # [J1.7+] Fixed issue with database error in editor button popup window

07-Nov-2011 : v2.11.2
 + Added translations: sl-SI
 ^ Cleaned code syntax (no longer guaranteed support for php 5.2.x and lower)
 # Fixed issue with tags being handled in some edit forms

17-Oct-2011 : v2.11.1
 ^ Updated translations: de-DE
 # Fixed security issue in NoNumber Framework plugin

08-Oct-2011 : v2.11.0
 ^ Changed NoNumber Elements plugin to NoNumber Framework
 ^ Cleaned up some code (like no more use of DS)
 ^ Improved installer
 ^ Moved common language strings to NoNumber Framework files
 ^ Moved translation language files to main package (no more language packs)
 # Fixed issue with installation problems on some Joomla 1.7 setups
 # [J1.7] Fixed issue with Editor Button settings not being handled
 # [J1.7] Fixed issue with Example Code field in Editor Button settings not working
 # [J1.7] Fixed issue with php debugging not working

05-Jul-2011 : v2.9.0
 + Added option to set security levels for css, js and php to default
 + Joomla 1.7 compatible!

20-Jun-2011 : v2.8.5
 # [J1.5] Fixed issue with installation problems

18-Jun-2011 : v2.8.4
 ^ Changed layout of settings
 ^ Changed use of elements
 ^ Changed way the mootools version is detected
 ^ Improved insertion of rich content in TinyMCE editor
 # Fixed issue with {source} tags being interpreted in frontend editor

01-Apr-2011 : v2.8.3
 # Fixed issue plugin being executed on raw format pages
 # Fixed issue with colors not being removed from source tags when inserting code

25-Mar-2011 : v2.8.2
 # Fixed issue with php error (get)

25-Mar-2011 : v2.8.1
 ^ Changed language files to be J1.6 ready
 # Fixed issue with editor button not working for registered/author level
 # Fixed issue with search component breaking in some cases
 # Fixed issue with tags being interpreted in frontend editor fields with very large contents

11-Feb-2011 : v2.8.0
 ^ Changed extension icon / logo
 # Fixed issue with public access to editor button popup page (security fix!)

14-Dec-2010 : v2.7.1
 # Cleaned up some code
 # Fixed issues with document being called to early
 # Fixed some issues with loading of language strings

25-Nov-2010 : v2.7.0
 + Added checks to see if NoNumber Elements plugin is installed/enabled
 ^ Fixed and updated all language strings
 ^ Improved code to make it lighter/faster
 # Fixed issue with tags being handled in edit fields

16-Nov-2010 : v2.6.0
 # Fixed extension causing pages to break on some setups
 # Fixed issue with not working in some forms (where they should)

15-Nov-2010 : v2.5.0
 ^ Made MooTools 1.2 compatible
 # Fixed issues with wrong version numbers in files
 # Fixed some missing language strings
 # Fixed some styling issues of PHP debug output

18-Oct-2010 : v2.4.10
 # Fixed faulty version number in package

18-Oct-2010 : v2.4.9
 # Fixed issue with language file not being loaded for comment strings in html output
 # Fixed issue with use of some special characters like à

24-Jul-2010 : v2.4.8
 ^ Changed way version and license information are displayed (now via ajax)
 ^ Changed way versions and licenses are checked (no more base64)
 # Fixed issue with plugin edit page give error due to missing file

19-Jul-2010 : v2.4.7
 # Fixed issue with usage of multiple php blocks without trailing semi-colon

07-Jul-2010 : v2.4.6
 ^ Improved some code to make it lighter
 # Fixed issue with errors in some cases when used in combination with Articles Anywhere

23-Jun-2010 : v2.4.5
 # Fixed issue with code looping, causing page timeouts

22-Jun-2010 : v2.4.4
 ^ Changed language strings used for comments
 ^ Improved code (=faster)
 # Fixed issue with enters before and after php output

02-Apr-2010 : v2.4.3
 ^ Made code a little lighter
 # Fixed issue with errors about registry for php 5.0.5
 # Fixed issue with errors on search page

09-Feb-2010 : v2.4.2
 ^ Reduced number of database queries
 # Fixed error on some articles when no author is set
 # Fixed issue with deprecated syntax for php 5.3+
 # Fixed issue with preg_match_all error in some cases (when article author is not set)

26-Jan-2010 : v2.4.1
 # Fixed issue with Missing argument errors in feeds
 # Fixed location of Joomla! DTD files

19-Jan-2010 : v2.4.0
 + Added Commercial License Code support
 ^ Added extra html to code helpers output to prevent editor stripping tags
 ^ Moved elements to separate global plugin (also used by other extensions)
 ^ Moved functions to helper file
 # Fixed issue with preservation of indentation on selection in IE
 # Fixed padding on editor button in fronted when no icon is shown

27-Nov-2009 : v2.3.2
 # Fixed issue with Sourcerer codes being handled in Joomfishplus edit page
 # Fixed issue with php errors when article does not pass security level

11-Nov-2009 : v2.3.1
 ^ Changed display of Sourcerer PHP Debugging
 # Fixed issue with PHP code breaking if last line is a comment

10-Nov-2009 : v2.3.0
 + Added option to define editor button text
 + Added option to show/hide editor button icon
 ^ Changed size of modal window for Sourcerer editor to maximum
 # Fixed issue with code from Sourcerer editor being messed up by html tags when using IE

28-Oct-2009 : v2.2.3
 ^ Changed file encoding to UTF-8
 ^ Changed method of indentation to output less html (1 tab image instead of 4 space images)
 ^ Changed output of code from Sourcerer editor when no color is kept (cleaner)
 # Fixed issue with wrong comment in html when PHP is not enabled or doesn't pass security

09-Oct-2009 : v2.2.2
 ^ Changed the update check
 # Fixed issue with changes in default settings not working

17-Sep-2009 : v2.2.0
 + Added option to preserve indentation of code in the content
 ^ Cleaned up some code
 ^ Completely change the editor button popup with special editor (EditArea)
 # Fixed issue with editor button popup not working on all setups
 # Fixed issue with errors when article author (created_by) does not exist

07-Aug-2009 : v2.1.8
 # Fixed issue with errors in feeds when using K2

05-Aug-2009 : v2.1.7
 ^ Made the toggling in settings faster and more stable
 # Fixed issue with textareas overlapping in settings (in IE)

01-Aug-2009 : v2.1.6
 # Fixed issue with html_entity_decode error on some setups (php4)

30-Jul-2009 : v2.1.5
 # Fixed issue with code styling tags not all being removed in final output

27-Jul-2009 : v2.1.4
 ^ Changed code to make the Sourcerer editor button window work faster/better
 # Fixed issue with Sourcerer editor button window not being accessible in some setups
 # Fixed issue with [SRC] tags sometimes showing
 # Fixed issue with code in Sourcerer editor button window not working properly in IE

17-Jul-2009 : v2.1.3
 # Fixed issue with error in Sourcerer editor button popup page

12-Jul-2009 : v2.1.2
 ^ Changed sliding toggle option (in admin settings) to work better in IE8
 # Fixed issues with php4 incompatibility

04-Jul-2009 : v2.1.1
 # Fixed issue with preg_replace error

03-Jul-2009 : v2.1.0
 + Added 3 ready available variables: $article, $user, $database
 + Added option to disable Sourcerer temporarily via url &disable_sourcerer=1
 ^ Changed the textarea element (made it resizable)
 ^ Made code a lot lighter (less memory load)
 ^ Moved frontend language to a separate file
 # Fixed issue with code in articles being executed twice
 # Fixed some comments not being placed correctly

26-Jun-2009 : v2.0.1
 + Added code coloring for html
 + Added fields to set the default rgb values for code coloring
 + Added syntax to escape html entities with underscore: &_...;
 ^ Changed auto installer
 ^ Changed the way the code is colored (more straightforward)
 # Fixed issue with special characters and &...; characters not being translated correctly

12-Jun-2009 : v2.0.0
 + Added a check to see if system plugin is installed in the editor button settings page
 + Added a lot of options to the editor button
 + Added a wizard
 + Added option to disable html cleanup with {source 0} tag
 ! Removed (the need for) the Sourcerer module and its settings
 ! Removed security check on article modifier (so now only checks creator)
 ! Removed the settings for Categories / Sections (is now together with Article settings)
 ! Removed update icon in administrator toolbar
 ^ Changed a lot of language code
 ^ Changed different administrator elements
 ^ Changed installation procedure (automatic installer/updater)
 ^ Changed tag syntax setting (can now only set word)
 ^ Changed the editor button from a simple insert to a complete Code Helper
 ^ Changed the link for more information
 ^ Changed the output of the PHP Debugging and enabled it only for (Super) Administrators
 ^ Changed the versioncheck
 ^ Changed the way PHP gets parsed: Now you can break PHP statements over multiple PHP blocks
 # Fixed issue with PHP vars over multiple Sourcerer tags
 # Fixed issue with editor button breaking if plugin was not installed
 # Fixed issue with editor button image not working on frontend
 # Fixed issue with editor button settings not working if plugin was disabled
 # Fixed issue with option to not use example code not working
 # Fixed issue with styling breaking the code (all html tags get stripped)
 # Fixed issue with using the {source} tags in paragraphs

26-Sep-2008 : v1.0.0
 + Added support for defining vars over multiple Sourcerer tags
 + First stable release
 ^ Changed a lot of code to standardize syntax
 ^ Changed the version check

03-Jul-2008 : v0.1.5
 # Fixed issue with params not being initialized properly (resulting in bug for components)

02-Jul-2008 : v0.1.4
 # Fixed an issue with special characters inside the Sourcerer tags

25-Jun-2008 : v0.1.3
 # Fixed a bug with the components compatibility

14-Jun-2008 : v0.1.2
 ^ Changed the bracket syntax for tags: now [[tag]] instead of [tag]. This because single brackets can be used in JavaScript and PHP.
 ^ Optimized the code a bit more

09-Jun-2008 : v0.1.1
 # Fixed some issues with security levels regarding articles

02-Jun-2008 : v0.1.0
 + First release (based on AnyTags! v2.2.2)